> For the complete documentation index, see [llms.txt](https://docs.caf.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.caf.io/caf-sdk/android/standalone-modules/document-detector/source-code.md).

# Source Code

```kotlin
class MainActivity : AppCompatActivity() {
    private lateinit var binding: ActivityMainBinding

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        binding = ActivityMainBinding.inflate(layoutInflater)
        setContentView(binding.root)

        binding.startDocumentDetectorButton.setOnClickListener {
            startDocumentDetector()
        }
    }

    private fun startDocumentDetector(upload: Boolean = false) {
        val documentDetector = buildDocumentDetector(upload)
        val intent = Intent(this, DocumentDetectorActivity::class.java)
        intent.putExtra(DocumentDetector.PARAMETER_NAME, documentDetector)
        startActivityForResult(intent, REQUEST_CODE)
    }

    private fun buildDocumentDetector(upload: Boolean = false): DocumentDetector? =
        DocumentDetector.Builder("eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiI2NTRjZmFlMWM5YTM0NTAwMDg4YzIwODUifQ.maH9fynasnaRR2Hm5PxQ1XzLxlVZiZSvpVDD9zVtfgs")
            .setDocumentCaptureFlow(
                arrayOf(
                    DocumentDetectorStep(Document.CNH_FRONT),
                    DocumentDetectorStep(Document.CNH_BACK),
                )
            )
            .setUploadSettings(
                UploadSettings(upload)
            )
            .setPersonId("12312312312")
            .setUseDeveloperMode(true)
            .setUseAdb(true)
            .setUseDebug(true)
            .build()

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (requestCode == REQUEST_CODE && resultCode == RESULT_OK) {
            val result = data?.getSerializableExtra(
                DocumentDetectorResult.PARAMETER_NAME
            ) as DocumentDetectorResult

            if (!result.wasSuccessful()) {
                result.sdkFailure?.let {
                    onSdkFailure(it)
                }
                return
            }

            println("DocumentDetectorResult: $result")
        } else {
            println("The user canceled the operation")
        }
        super.onActivityResult(requestCode, resultCode, data)
    }

    private fun onSdkFailure(sdkFailure: SDKFailure?) {
        when (sdkFailure) {
            is InvalidTokenReason -> {
                println("SDKFailure: The token entered as a parameter is not valid, please revise it")
            }
            is PermissionReason -> {
                println("SDKFailure: The user did not grant the necessary permissions")
            }
            is AvailabilityReason -> {
                println("SDKFailure: Instructions are sent in: ${sdkFailure.message}")
            }
            is NetworkReason -> {
                println("SDKFailure: There was a problem with the internet connection")
            }
            is ServerReason -> {
                println("SDKFailure: There was a problem in any communication with the CAF servers, let us know!")
            }
            is SecurityReason -> {
                println("SDKFailure: There was a security problem on the user's device")
            }
            is StorageReason -> {
                println("SDKFailure: There was a problem with the internal storage of the user's device")
            }
            is LibraryReason -> {
                println("SDKFailure: There was a problem with the internal library")
            }
            else -> {
                println("SDKFailure: Unknown reason")
            }
        }
    }

    companion object {
        private const val REQUEST_CODE = 123456
    }
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.caf.io/caf-sdk/android/standalone-modules/document-detector/source-code.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
